DispatcherType (Servlet 4.0 API Documentation - Apache Tomcat 9.0.121)
Description: declaration: package: javax.servlet, enum: DispatcherType

# Enum DispatcherType

java.lang.Object
java.lang.Enum<DispatcherType>
javax.servlet.DispatcherType

All Implemented Interfaces:
  `Serializable, Comparable<DispatcherType>, java.lang.constant.Constable`

public enum DispatcherType extends Enum<DispatcherType>
Enumeration of dispatcher types. Used both to define filter mappings and by Servlets to determine why they were called.

Since:
  Servlet 3.0

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ASYNC`
  `AsyncContext.dispatch()`, `AsyncContext.dispatch(String)` and `AsyncContext.addListener(AsyncListener, ServletRequest, ServletResponse)`
  `ERROR`
  When the container has passed processing to the error handler mechanism such as a defined error page.
  `FORWARD`
  `RequestDispatcher.forward(ServletRequest, ServletResponse)`
  `INCLUDE`
  `RequestDispatcher.include(ServletRequest, ServletResponse)`
  `REQUEST`
  Normal (non-dispatched) requests.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DispatcherType`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static DispatcherType[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### FORWARD

    public static final DispatcherType FORWARD
    `RequestDispatcher.forward(ServletRequest, ServletResponse)`

  - ### INCLUDE

    public static final DispatcherType INCLUDE
    `RequestDispatcher.include(ServletRequest, ServletResponse)`

  - ### REQUEST

    public static final DispatcherType REQUEST
    Normal (non-dispatched) requests.

  - ### ASYNC

    public static final DispatcherType ASYNC
    `AsyncContext.dispatch()`, `AsyncContext.dispatch(String)` and `AsyncContext.addListener(AsyncListener, ServletRequest, ServletResponse)`

  - ### ERROR

    public static final DispatcherType ERROR
    When the container has passed processing to the error handler mechanism such as a defined error page.

- ## Method Details

  - ### values

    public static DispatcherType[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static DispatcherType valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null